%define R16x16M_Local_Bytes 20
%define R16x16M_Plotter esp+16
%define R16x16M_BG_Table esp+12
%define R16x16M_Current_Line esp+8
%define R16x16M_BaseDestPtr esp+4
%define R16x16M_Lines esp

%macro Render_16x16M 1
ALIGNC
EXPORT_C Render_16x16M_C%1
%ifndef NO_NP_RENDER
 mov ecx,_Plot_Lines_Unclipped_NP_16x16M_Table_C%1
 test al,al
 jnz .have_plotter
%endif

 mov ecx,_Plot_Lines_Unclipped_V_16x16M_Table_C%1

.have_plotter:
%if %1 == 2
 mov eax,[M0_Color+edx]
 mov [Palette_Base],eax
%endif
 jmp short Render_16x16M_Base
%endmacro

Render_16x16M 2
Render_16x16M 4
Render_16x16M 8

ALIGNC
Render_16x16M_Base:
 push ecx
 push edx
 push ebx
 push edi
 push ebp

.next_line:
 mov edx,[R16x16M_BG_Table]

 mov eax,[R16x16M_Current_Line]
 call Sort_Screen_Height_Mosaic

 mov eax,[R16x16M_Current_Line]
 mov ebx,[Mosaic_Size_Select]
 xor ecx,ecx
 mov cl,[_MosaicCount+eax+ebx]
 mov al,[_MosaicLine+eax+ebx]
 push ecx
 SORT_TILES_16_TALL  ; This sets up the screen vert 2!
 mov eax,[SetAddress+edx]
 pop ecx
 mov ebp,[R16x16M_Lines]
 mov [TilesetAddress],eax

 cmp ecx,ebp
 ja .no_multi
 mov ebp,ecx
.no_multi:
 cmp ebp,byte 8
 jb .not_too_many
 mov ebp,8
.not_too_many:
 mov ecx,[R16x16M_Lines]
 mov eax,[R16x16M_Current_Line]
 sub ecx,ebp
 add eax,ebp
 mov [R16x16M_Lines],ecx
 mov edi,[R16x16M_BaseDestPtr]
 mov [R16x16M_Current_Line],eax
 mov eax,ebp
 shl eax,8
 lea ecx,[edi+ebp*GfxBufferLineSlack]
 add eax,ecx
 mov ecx,[R16x16M_Plotter]
 mov [R16x16M_BaseDestPtr],eax
 mov eax,[_SNES_Screen8]
 add edi,eax
 mov ecx,[ecx+ebp*4-4]

 push ecx
 push ebx
 add ebx,[VLMapAddress+edx]
%ifndef NO_EARLY_CACHE_LOAD
 Cache_Load_Lines ebp,edi,edx,esi
%endif

 mov ecx,[HScroll+edx]
 mov ebp,[FirstPixel+edx]
 and ecx,0x1FF
 sub ecx,0x100
 ja .fixup

 mov ecx,0x100
 jmp .fixup_done

.fixup:
 mov eax,0xFF
 mov esi,[Mosaic_Size_Select]
 sub eax,ecx
 xor ecx,ecx
 mov cl,[_MosaicCount+eax+esi]
 add ecx,eax
.fixup_done:

 push ecx
;pixelcount1 = (HScroll:0-8) <= 256 ? 256 :
; 256 - (HScroll:0-7) + Mosaic_Count[256 - (HScroll:0-7)]
;pixelcount2 = 256-pixelcount1
;firstpixel2 = ((HScroll:0-7) - pixelcount2) & 15
;firsttile2 = ((HScroll:0-7) - pixelcount2) / 16 * 2

 call dword [esp+8]
 mov edx,[R16x16M_BG_Table+12]
 pop ebp
 pop ebx
 cmp ebp,0x100
 je .no_second_set

 xor eax,eax
 mov ecx,0x100
 mov al,[HScroll+edx]
 sub ecx,ebp
 sub eax,ecx
 mov ebp,eax
 and ebp,byte 15
 shr eax,byte 4
 mov esi,[VRMapAddress+edx]
 add eax,eax
 add ebx,esi
 add ebx,eax
 call dword [esp]
.no_second_set:

 pop ecx
%ifndef LAYERS_PER_LINE
 cmp dword [R16x16M_Lines],0
 jnz near .next_line
%endif

 mov edx,[R16x16M_BG_Table]
 mov al,[Tile_Priority_Used]
 mov [Priority_Used+edx],al
 mov ah,[Tile_Priority_Unused]
 mov [Priority_Unused+edx],ah

 add esp,byte R16x16M_Local_Bytes
 ret

;%1 = label, %2 = priority - 0 = none, 1 = low, 2 = high, %3 = lines
%macro Plot_Lines_Unclipped_16x16M_C2 3
ALIGNC
%if %2 > 0
%%wrong_priority_last:
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],cl
%endif
 add edi,ecx
 add ebp,ecx
%%return:
 ret

ALIGNC
%1_check:
 mov eax,[Mosaic_Size]
%%wrong_priority_same_tile:
 cmp ecx,eax
 jbe %%wrong_priority_last
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],al
%endif
 add edi,eax
 add ebp,eax
 sub ecx,eax

 cmp ebp,byte 16
 jb %%wrong_priority_same_tile
%endif

%%next_tile:
 mov eax,ebp
 and ebp,byte 15
 shr eax,4
 add eax,eax
 add ebx,eax        ; Update screen pointer

EXPORT_C %1     ; Define label, entry point
 mov al,[ebx+1]

 Check_Tile_Priority %2, %1_check

 push ebx
 push ebp
 mov ebp,[LineAddressY]
 test al,al         ; Check Y flip
 mov si,[ebx]       ; Get tile #
 js %%flip_y
 mov ebp,[LineAddress]

%%flip_y:
 shl esi,3
 mov dl,al
 add esi,ebp
 and edx,byte 7*4   ; Get palette

 mov ebp,[Palette_Base]

 mov edx,[palette_2bpl+edx]
 or edx,ebp         ; Adjust palette for mode 0
 pop ebp

 add al,al      ; Get X flip (now in MSB)
 mov eax,[Mosaic_Size]
 js near %%xflip

%%flip_none_same_tile:
 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte -1
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF * 4 / 8 ; Clip to VRAM
 lea esi,[_TileCache2+esi*8+ebp+1]
 pop ebp

 cmp ecx,eax
 ja %%flip_none_partial
 mov eax,ecx
%%flip_none_partial:
 mov bl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 and bl,dl
 jz %%flip_none_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;edx = palette, bl = pixel
 add ebp,eax
 sub ecx,eax

%%flip_none_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],bl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_none_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_none_return

 cmp ebp,byte 16
 jb %%flip_none_same_tile

 pop ebx
 jmp %%next_tile

ALIGNC
%%flip_none_empty_run:
 add edi,eax
 add ebp,eax
 sub ecx,eax
 jz %%flip_none_return

 cmp ebp,byte 16
 jb near %%flip_none_same_tile

 pop ebx
 jmp %%next_tile

%%flip_none_return:
 pop ebx
 ret

ALIGNC
%%xflip:
 xor ebp,byte -1
%%flip_x_same_tile:
 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte 8
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF * 4 / 8 ; Clip to VRAM
 lea esi,[_TileCache2+esi*8+ebp+8]
 pop ebp

 cmp ecx,eax
 ja %%flip_x_partial
 mov eax,ecx
%%flip_x_partial:
 mov bl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 and bl,dl
 jz %%flip_x_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;edx = palette, bl = pixel
 sub ebp,eax
 sub ecx,eax

%%flip_x_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],bl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_x_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja %%flip_x_same_tile

 pop ebx
 xor ebp,byte -1
 jmp %%next_tile

%%flip_x_empty_run:
 add edi,eax
 sub ebp,eax
 sub ecx,eax
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja near %%flip_x_same_tile

 pop ebx
 xor ebp,byte -1
 jmp %%next_tile

%%flip_x_return:
 pop ebx
 ret
%endmacro

;%1 = label, %2 = priority - 0 = none, 1 = low, 2 = high, %3 = lines
%macro Plot_Lines_Unclipped_16x16M_C4 3
ALIGNC
%if %2 > 0
%%wrong_priority_last:
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],cl
%endif
 add edi,ecx
 add ebp,ecx
%%return:
 ret

ALIGNC
%1_check:
 mov eax,[Mosaic_Size]
%%wrong_priority_same_tile:
 cmp ecx,eax
 jbe %%wrong_priority_last
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],al
%endif
 add edi,eax
 add ebp,eax
 sub ecx,eax

 cmp ebp,byte 16
 jb %%wrong_priority_same_tile
%endif

%%next_tile:
 mov eax,ebp
 and ebp,byte 15
 shr eax,4
 add eax,eax
 add ebx,eax        ; Update screen pointer

EXPORT_C %1     ; Define label, entry point
 mov al,[ebx+1]

 Check_Tile_Priority %2, %1_check

 push ebx
 push ebp
 mov ebp,[LineAddressY]
 test al,al         ; Check Y flip
 mov si,[ebx]       ; Get tile #
 js %%flip_y
 mov ebp,[LineAddress]

%%flip_y:
 shl esi,3
 mov dl,al
 add esi,ebp
 and edx,byte 7*4   ; Get palette

 mov edx,[palette_4bpl+edx]
 pop ebp

 add al,al      ; Get X flip (now in MSB)
 mov eax,[Mosaic_Size]
 js near %%xflip

%%flip_none_same_tile:
 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte -1
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF * 2 / 8 ; Clip to VRAM
 lea esi,[_TileCache4+esi*8+ebp+1]
 pop ebp

 cmp ecx,eax
 ja %%flip_none_partial
 mov eax,ecx
%%flip_none_partial:
 mov bl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 and bl,dl
 jz %%flip_none_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;edx = palette, bl = pixel
 add ebp,eax
 sub ecx,eax

%%flip_none_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],bl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_none_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_none_return

 cmp ebp,byte 16
 jb %%flip_none_same_tile

 pop ebx
 jmp %%next_tile

%%flip_none_empty_run:
 add edi,eax
 add ebp,eax
 sub ecx,eax
 jz %%flip_none_return

 cmp ebp,byte 16
 jb near %%flip_none_same_tile

 pop ebx
 jmp %%next_tile

%%flip_none_return:
 pop ebx
 ret

ALIGNC
%%xflip:
 xor ebp,byte -1
%%flip_x_same_tile:
 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte 8
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF * 2 / 8 ; Clip to VRAM
 lea esi,[_TileCache4+esi*8+ebp+8]
 pop ebp

 cmp ecx,eax
 ja %%flip_x_partial
 mov eax,ecx
%%flip_x_partial:
 mov bl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 and bl,dl
 jz %%flip_x_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;edx = palette, bl = pixel
 sub ebp,eax
 sub ecx,eax

%%flip_x_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],bl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_x_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja %%flip_x_same_tile

 pop ebx
 xor ebp,byte -1
 jmp %%next_tile

%%flip_x_empty_run:
 add edi,eax
 sub ebp,eax
 sub ecx,eax
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja near %%flip_x_same_tile

 pop ebx
 xor ebp,byte -1
 jmp %%next_tile

%%flip_x_return:
 pop ebx
 ret
%endmacro

;for mosaic, keep track of # pixels done, return # tiles in next set skipped

;%1 = label, %2 = priority - 0 = none, 1 = low, 2 = high, %3 = lines
%macro Plot_Lines_Unclipped_16x16M_C8 3
ALIGNC
%if %2 > 0
%%wrong_priority_last:
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],cl
%endif
 add edi,ecx
 add ebp,ecx
%%return:
 ret

ALIGNC
%1_check:
 mov eax,[Mosaic_Size]
%%wrong_priority_same_tile:
 cmp ecx,eax
 jbe %%wrong_priority_last
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Unused],al
%endif
 add edi,eax
 add ebp,eax
 sub ecx,eax

 cmp ebp,byte 16
 jb %%wrong_priority_same_tile
%endif

%%next_tile:
 mov eax,ebp
 and ebp,byte 15
 shr eax,4
 add eax,eax
 add ebx,eax        ; Update screen pointer

EXPORT_C %1     ; Define label, entry point
 mov al,[ebx+1]

 Check_Tile_Priority %2, %1_check

 push ebp
 mov si,[ebx]       ; Get tile #
 shl esi,3          ; 8
 test al,al ; Check Y flip
 mov ebp,[LineAddressY]
 js %%flip_y
 mov ebp,[LineAddress]

%%flip_y:

 add esi,ebp
 pop ebp

 add al,al      ; Get X flip (now in MSB)
 mov eax,[Mosaic_Size]
 js near %%xflip

%%flip_none_same_tile:

 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte -1
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF / 8 ; Clip to VRAM
 lea esi,[_TileCache8+esi*8+ebp+1]
 pop ebp

 cmp ecx,eax
 ja %%flip_none_partial
 mov eax,ecx
%%flip_none_partial:
 mov dl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 test dl,dl
 jz %%flip_none_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;ebx = screen map, dl = pixel
 add ebp,eax
 sub ecx,eax

%%flip_none_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],dl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_none_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_none_return

 cmp ebp,byte 16
 jb %%flip_none_same_tile

 jmp %%next_tile

ALIGNC
%%flip_none_empty_run:
 add edi,eax
 add ebp,eax
 sub ecx,eax
 jz %%flip_none_return

 cmp ebp,byte 16
 jb near %%flip_none_same_tile

 jmp %%next_tile

%%flip_none_return:
 ret

ALIGNC
%%xflip:
 xor ebp,byte -1
%%flip_x_same_tile:
 push esi
 push ebp
 and ebp,byte 8
 add esi,ebp
 xor ebp,byte 8
 and esi,0x3FF * 8 + 7  ; Clip to tileset
 add esi,[TilesetAddress]
 and esi,0xFFFF * 2 / 8 ; Clip to VRAM
 lea esi,[_TileCache8+esi*8+ebp+8]
 pop ebp

 cmp ecx,eax
 ja %%flip_x_partial
 mov eax,ecx
%%flip_x_partial:
 mov dl,[esi+ebp]
 pop esi
%if %2 == 1 || %2 == 3
 mov [Tile_Priority_Used],al
%endif
 test dl,dl
 jz %%flip_x_empty_run

;eax = count, esi = source base, ebp = offset, edi = dest, ecx = # left
;ebx = screen map, dl = pixel
 sub ebp,eax
 sub ecx,eax

%%flip_x_next_pixel:
%assign PLUM16x16_Dest_Offset 0
%rep %3
 mov [edi+PLUM16x16_Dest_Offset],dl
%assign PLUM16x16_Dest_Offset (PLUM16x16_Dest_Offset + GfxBufferLinePitch)
%endrep
 inc edi
 dec eax
 jnz %%flip_x_next_pixel

 mov eax,[Mosaic_Size]
 test ecx,ecx
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja %%flip_x_same_tile

 xor ebp,byte -1
 jmp %%next_tile

ALIGNC
%%flip_x_empty_run:
 add edi,eax
 sub ebp,eax
 sub ecx,eax
 jz %%flip_x_return

 cmp ebp,byte ~16
 ja near %%flip_x_same_tile

 xor ebp,byte -1
 jmp %%next_tile

%%flip_x_return:
 ret
%endmacro

;%1 = depth, %2 = count
%macro Generate_Line_Plotters_16x16M 2
%ifndef NO_NP_RENDER
 Plot_Lines_Unclipped_16x16M_C%1 Plot_Lines_%2_Unclipped_NP_16x16M_C%1,0,%2
%endif
 Plot_Lines_Unclipped_16x16M_C%1 Plot_Lines_%2_Unclipped_V_16x16M_C%1,3,%2
%endmacro

%macro Generate_Line_Plotters_16x16M_Depth 1
Generate_Line_Plotters_16x16M %1,1
Generate_Line_Plotters_16x16M %1,2
Generate_Line_Plotters_16x16M %1,3
Generate_Line_Plotters_16x16M %1,4
Generate_Line_Plotters_16x16M %1,5
Generate_Line_Plotters_16x16M %1,6
Generate_Line_Plotters_16x16M %1,7
Generate_Line_Plotters_16x16M %1,8
%endmacro

Generate_Line_Plotters_16x16M_Depth 2
Generate_Line_Plotters_16x16M_Depth 4
Generate_Line_Plotters_16x16M_Depth 8

section .data
;%1 = type, %2 = depth
%macro Generate_Line_Plotter_Table_16x16M 2
ALIGND
EXPORT_C Plot_Lines_Unclipped_%1_16x16M_Table_C%2
dd _Plot_Lines_1_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_2_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_3_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_4_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_5_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_6_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_7_Unclipped_%1_16x16M_C%2
dd _Plot_Lines_8_Unclipped_%1_16x16M_C%2
%endmacro

%ifndef NO_NP_RENDER
Generate_Line_Plotter_Table_16x16M NP,2
Generate_Line_Plotter_Table_16x16M NP,4
Generate_Line_Plotter_Table_16x16M NP,8
%endif

Generate_Line_Plotter_Table_16x16M V,2
Generate_Line_Plotter_Table_16x16M V,4
Generate_Line_Plotter_Table_16x16M V,8

section .text
